import json5 from 'json5';
export const getGraphData = (deep, links, spaceId) => {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y, _z, _0, _1;
    let graphData = { nodes: [], edges: [] };
    console.log({ links });
    for (let i = 0; i < links.length; i++) {
        const link = links[i];
        const ml = deep.minilinks;
        const focus = (_b = (_a = link === null || link === void 0 ? void 0 : link.inByType) === null || _a === void 0 ? void 0 : _a[deep.idLocal('@deep-foundation/core', 'Focus')]) === null || _b === void 0 ? void 0 : _b.find(f => f.from_id === spaceId);
        const isFocusSpace = (link.type_id === deep.idLocal('@deep-foundation/core', 'Focus') && link._applies.includes('space')) || (((_c = link === null || link === void 0 ? void 0 : link.to) === null || _c === void 0 ? void 0 : _c.type_id) === deep.idLocal('@deep-foundation/core', 'Focus') && link._applies.includes('space'));
        let _value = '';
        let _name = '';
        let _type = '';
        let _symbol = '';
        if (typeof ((_d = link === null || link === void 0 ? void 0 : link.value) === null || _d === void 0 ? void 0 : _d.value) !== 'undefined') {
            let json;
            try {
                json = json5.stringify(link === null || link === void 0 ? void 0 : link.value.value);
            }
            catch (error) { }
            _value = (typeof (link === null || link === void 0 ? void 0 : link.value.value) === 'object' && json
                ? json : link === null || link === void 0 ? void 0 : link.value.value);
            if (typeof (_value) === 'string')
                _value = _value.split('\n')[0];
            if (_value.length > 20)
                _value = _value.slice(0, 11) + '...' + _value.slice(-9, _value.length);
        }
        if ((_h = (_g = (_f = (_e = link === null || link === void 0 ? void 0 : link.inByType) === null || _e === void 0 ? void 0 : _e[deep.idLocal('@deep-foundation/core', 'Contain')]) === null || _f === void 0 ? void 0 : _f[0]) === null || _g === void 0 ? void 0 : _g.value) === null || _h === void 0 ? void 0 : _h.value) {
            _name = `name:${(_m = (_l = (_k = (_j = link === null || link === void 0 ? void 0 : link.inByType) === null || _j === void 0 ? void 0 : _j[deep.idLocal('@deep-foundation/core', 'Contain')]) === null || _k === void 0 ? void 0 : _k[0]) === null || _l === void 0 ? void 0 : _l.value) === null || _m === void 0 ? void 0 : _m.value}`;
        }
        if ((_q = (_p = (_o = ml.byTo[link === null || link === void 0 ? void 0 : link.type_id]) === null || _o === void 0 ? void 0 : _o.find(l => l.type_id === deep.idLocal('@deep-foundation/core', 'Contain'))) === null || _p === void 0 ? void 0 : _p.value) === null || _q === void 0 ? void 0 : _q.value) {
            _type = `type:${(_t = (_s = (_r = ml.byTo[link === null || link === void 0 ? void 0 : link.type_id]) === null || _r === void 0 ? void 0 : _r.find(l => l.type_id === deep.idLocal('@deep-foundation/core', 'Contain'))) === null || _s === void 0 ? void 0 : _s.value) === null || _t === void 0 ? void 0 : _t.value}`;
        }
        if ((_w = (_v = (_u = ml.byTo[link === null || link === void 0 ? void 0 : link.type_id]) === null || _u === void 0 ? void 0 : _u.find(l => l.type_id === deep.idLocal('@deep-foundation/core', 'Symbol'))) === null || _v === void 0 ? void 0 : _v.value) === null || _w === void 0 ? void 0 : _w.value) {
            _symbol = (_z = (_y = (_x = ml.byTo[link === null || link === void 0 ? void 0 : link.type_id]) === null || _x === void 0 ? void 0 : _x.find(l => l.type_id === deep.idLocal('@deep-foundation/core', 'Symbol'))) === null || _y === void 0 ? void 0 : _y.value) === null || _z === void 0 ? void 0 : _z.value;
        }
        const has_focus = !!((_1 = (_0 = focus === null || focus === void 0 ? void 0 : focus.value) === null || _0 === void 0 ? void 0 : _0.value) === null || _1 === void 0 ? void 0 : _1.x);
        const graphNode = Object.assign({ "id": link.id, "from_id": link.from_id, "to_id": link.to_id, "type_id": link.type_id, "name": (_name ? `${_name}` : undefined), "type": (_type ? `${_type}` : undefined), "idstring": `${link.id}` }, (has_focus ? {
            x: focus.value.value.x,
            y: focus.value.value.y,
            z: focus.value.value.z,
        } : {}));
        graphData.nodes.push(graphNode);
    }
    console.log(graphData.nodes);
    const linkIds = links.map((link) => (link.id));
    const linkTypeIds = links.map((link) => (link.type_id));
    const spaceTypes = links.filter((link) => (link.type_id === 1)).map((link) => link.id);
    const typedLinks = links.filter((link) => (spaceTypes.includes(link.type_id)));
    console.log({ spaceTypes });
    console.log({ typedLinks });
    const typedEdges = typedLinks.map((l) => ({ "source": l.id, "target": l.type_id, "type": "type" }));
    const edges = links.filter((l) => ((l.to_id && l.from_id !== 0) &&
        (linkIds.includes(l.to_id) &&
            linkIds.includes(l.from_id)))).map((l) => [{ "source": l.from_id, "target": l.id, "type": "from" }, { "source": l.id, "target": l.to_id, "type": "to" }]).flat();
    edges.push(...typedEdges);
    graphData.edges = edges;
    console.log(graphData);
    return graphData;
};
//# sourceMappingURL=get-graph-data.js.map