var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, Fragment as _Fragment, jsxs as _jsxs } from "react/jsx-runtime";
import * as chakra from '@chakra-ui/react';
import * as icons from '@chakra-ui/icons';
import dynamic from 'next/dynamic';
import { DeepClient, useDeep, useDeepSubscription } from "@deep-foundation/deeplinks/imports/client";
import { evalClientHandler as deepclientEvalClientHandler } from '@deep-foundation/deeplinks/imports/client-handler';
import { useMinilinksFilter } from "@deep-foundation/deeplinks/imports/minilinks";
import axios from 'axios';
import * as axiosHooks from 'axios-hooks';
import * as classnames from 'classnames';
import React, { useEffect, useRef, useState } from 'react';
import * as motion from 'framer-motion';
import Linkify from 'react-linkify';
import * as reactHotkeysHook from 'react-hotkeys-hook';
import * as debounce from '@react-hook/debounce';
import * as json5 from 'json5';
import * as bs from 'react-icons/bs';
import * as fi from 'react-icons/fi';
import * as tb from 'react-icons/tb';
import * as ci from 'react-icons/ci';
import { IconContext } from 'react-icons';
import * as editor from 'slate';
import * as slate from 'slate-react';
import SoftBreak from 'slate-soft-break';
import { slateToHtml, htmlToSlate } from 'slate-serializers';
import isHotkey from 'is-hotkey';
import * as Resizable from 're-resizable';
import { useContainer, useSpaceId, useRefAutofill, useFocusMethods, useShowExtra, useBreadcrumbs, useTraveler } from './hooks';
import { CytoEditorPreview } from './cyto/editor-preview';
import { CustomizableIcon } from './icons-provider';
import { useChackraColor, useChackraGlobal } from './get-color';
import { EditorTextArea } from './editor/editor-textarea';
import { BubbleArrowLeft } from './svg/bubble-arrow-left';
import { CytoReactLinkAvatar } from './cyto-react-avatar';
import { DeepWysiwyg, BlockButton, MarkButton, useStringSaver } from './deep-wysiwyg';
import { Resize } from './resize';
import * as rjsfCore from '@rjsf/core';
import * as rjsfChakra from '@rjsf/chakra-ui';
import * as rjsfValidator from '@rjsf/validator-ajv8';
import * as aframeReact from '@belivvr/aframe-react';
import { Entity, Scene } from 'aframe-react';
import { CatchErrors } from './react-errors';
import _ from 'lodash';
import md5 from "md5";
import { v4 as uuidv4 } from 'uuid';
import * as d3d from 'd3-force-3d';
import * as D3 from 'd3';
import WordCloud from 'react-d3-cloud';
import ReactResizeDetector from 'react-resize-detector';
import queryStore from '@deep-foundation/store/query';
import localStore from '@deep-foundation/store/local';
import * as recharts from 'recharts';
const MonacoEditor = dynamic(() => import('@monaco-editor/react').then(m => m.default), { ssr: false });
DeepClient.resolveDependency = (path) => __awaiter(void 0, void 0, void 0, function* () {
    if (path == 'peerjs') {
        return yield import('peerjs');
    }
    else if (path == 'node-sound') {
        return yield import('./aframe/components/node-sound');
    }
    else if (path == 'dragger') {
        return yield import('./aframe/components/dragger');
    }
    else if (path == 'rotator') {
        return yield import('./aframe/components/rotator');
    }
    else if (path == 'scaler') {
        return yield import('./aframe/components/scaler');
    }
    else if (path == 'use-engine-tick') {
        return yield import('./aframe/components/tick');
    }
    else if (path == 'el-movement') {
        return yield import('./aframe/components/el-movement');
    }
    else {
        return r(path);
    }
});
export const r = (path) => {
    if (r.list[path])
        return r.list[path];
    throw new Error(`Module not found: Can't resolve ${path}`);
};
r.list = {
    'lodash': _,
    '@chakra-ui/react': chakra,
    'react': React,
    'axios': axios,
    'axios-hooks': axiosHooks,
    'classnames': classnames,
    'slate-soft-break': SoftBreak,
    'slate-serializers': { slateToHtml, htmlToSlate },
    'react-hotkeys-hook': reactHotkeysHook,
    '@react-hook/debounce': debounce,
    'json5': json5,
    'framer-motion': motion,
    'slate': editor,
    'slate-react': slate,
    'is-hotkey': isHotkey,
    're-resizable': Resizable,
    '@monaco-editor/react': MonacoEditor,
    '@chakra-ui/icons': icons,
    '@deep-foundation/deepcase': {
        useContainer,
        useSpaceId,
        useFocusMethods,
        useBreadcrumbs,
        useShowExtra,
        useTraveler,
        CytoEditorPreview,
        CustomizableIcon,
        Resize,
        EditorTextArea,
        ClientHandler,
        BubbleArrowLeft,
        CytoReactLinkAvatar,
        DeepWysiwyg,
        useStringSaver,
        BlockButton,
        MarkButton,
        useRefAutofill,
        useChackraColor,
        useChackraGlobal,
    },
    '@deep-foundation/deeplinks': {
        useMinilinksFilter
    },
    'react-icons/bs': bs,
    'react-icons/fi': fi,
    'react-icons/ci': ci,
    'react-icons/tb': tb,
    'react-icons': IconContext,
    'react-linkify': Linkify,
    '@rjsf/core': rjsfCore,
    '@rjsf/chakra-ui': rjsfChakra,
    '@rjsf/validator-ajv8': rjsfValidator,
    '@belivvr/aframe-react': aframeReact,
    'aframe-react': { Entity, Scene },
    'md5': md5,
    'uuid': uuidv4,
    'd3-force-3d': d3d,
    'd3': D3,
    'react-d3-cloud': WordCloud,
    'react-resize-detector': ReactResizeDetector,
    '@deep-foundation/store/query': queryStore,
    '@deep-foundation/store/local': localStore,
    'recharts': recharts,
};
export function evalClientHandler({ value, deep, input = {}, }) {
    return __awaiter(this, void 0, void 0, function* () {
        return yield deepclientEvalClientHandler({
            value, deep, input: Object.assign({ require: r }, input),
        });
    });
}
;
export function ClientHandlerRenderer(_a) {
    var { Component, fillSize = false, onClose } = _a, props = __rest(_a, ["Component", "fillSize", "onClose"]);
    return _jsx(_Fragment, { children: typeof (Component) === 'function' && _jsx(Component, Object.assign({ onClose: onClose, fillSize: fillSize }, props, { style: Object.assign(Object.assign({}, (fillSize ? { width: '100%', height: '100%' } : {})), props === null || props === void 0 ? void 0 : props.style) })) });
}
export function useFindClientHandler(_a) {
    var { linkId, handlerId, context = [], ml, onClose, fillSize } = _a, props = __rest(_a, ["linkId", "handlerId", "context", "ml", "onClose", "fillSize"]);
    const deep = useDeep();
    const [hid, setHid] = useState();
    useEffect(() => {
        (() => __awaiter(this, void 0, void 0, function* () {
            if (hid)
                return;
            if (handlerId) {
                const { data: handlers } = yield deep.select({
                    execution_provider_id: { _eq: deep.idLocal('@deep-foundation/core', 'JSExecutionProvider'), },
                    isolation_provider_id: { _eq: deep.idLocal('@deep-foundation/core', 'ClientJSIsolationProvider'), },
                    handler_id: { _eq: handlerId },
                }, { table: 'handlers', returning: 'handler_id dist_id src_id' });
                if (handlers === null || handlers === void 0 ? void 0 : handlers[0])
                    setHid(handlers === null || handlers === void 0 ? void 0 : handlers[0]);
            }
            else {
                const { data: handlers } = yield deep.select({
                    execution_provider_id: { _eq: deep.idLocal('@deep-foundation/core', 'JSExecutionProvider'), },
                    isolation_provider_id: { _eq: deep.idLocal('@deep-foundation/core', 'ClientJSIsolationProvider'), },
                    handler: {
                        in: {
                            type_id: { _eq: yield deep.id('@deep-foundation/deepcase', 'Context') },
                            from_id: { _in: context }
                        },
                    },
                }, { table: 'handlers', returning: 'handler_id dist_id src_id' });
                if (handlers === null || handlers === void 0 ? void 0 : handlers[0])
                    setHid(handlers === null || handlers === void 0 ? void 0 : handlers[0]);
            }
        }))();
    }, [context, handlerId, hid]);
    return hid;
}
export function ClientHandler(_props) {
    var _a;
    const { linkId, handlerId, context = [], ml, onClose, fillSize, error: outerError } = _props, props = __rest(_props, ["linkId", "handlerId", "context", "ml", "onClose", "fillSize", "error"]);
    const deep = useDeep();
    const _ml = ml || (deep === null || deep === void 0 ? void 0 : deep.minilinks);
    const hid = useFindClientHandler(_props);
    const { data: files } = useDeepSubscription({
        id: (hid === null || hid === void 0 ? void 0 : hid.dist_id) || 0,
    });
    const file = files === null || files === void 0 ? void 0 : files[0];
    const [{ Component, errored } = {}, setState] = React.useState({ Component: undefined, errored: undefined });
    const lastEvalRef = useRef(0);
    useEffect(() => {
        var _a;
        if (!hid)
            return;
        const value = (_a = file === null || file === void 0 ? void 0 : file.value) === null || _a === void 0 ? void 0 : _a.value;
        console.log('ClientHandler evalClientHandler', { linkId, handlerId, context, file, value, hid, files });
        if (!value) {
            return;
        }
        const evalId = ++lastEvalRef.current;
        evalClientHandler({ value, deep }).then(({ data, error }) => {
            if (evalId === lastEvalRef.current) {
                console.log('ClientHandler evalClientHandler setState', { file, data, error });
                if (!error) {
                    setState(() => ({ Component: data }));
                    (erroredResetRef === null || erroredResetRef === void 0 ? void 0 : erroredResetRef.current) && (erroredResetRef === null || erroredResetRef === void 0 ? void 0 : erroredResetRef.current(), erroredResetRef.current = undefined);
                }
                else {
                    setErrorRef.current && setErrorRef.current(error);
                    setState({ Component: undefined, errored: error });
                }
            }
            else {
                console.log('ClientHandler evalClientHandler outdated', { file, data, error, evalId, 'lastEvalRef.current': lastEvalRef.current });
            }
        });
    }, [(_a = file === null || file === void 0 ? void 0 : file.value) === null || _a === void 0 ? void 0 : _a.value, hid]);
    const erroredResetRef = useRef();
    const setErrorRef = useRef();
    return (_jsx(_Fragment, { children: _jsx(CatchErrors, { error: errored || outerError, errorRenderer: (error, reset) => {
                var _a;
                erroredResetRef.current = reset;
                return _jsx("div", { style: Object.assign(Object.assign({}, (fillSize ? { width: '100%', height: '100%' } : {
                        width: 500, maxHeight: 500
                    })), { overflow: 'scroll' }), children: _jsxs(chakra.Alert, { style: {
                            width: 'max-content',
                        }, status: 'error', variant: 'subtle', flexDirection: 'column', alignItems: 'left', justifyContent: 'left', textAlign: 'left', children: [_jsx(chakra.Button, { disabled: !Component, width: "100%", onClick: reset, children: "reset" }), _jsx(chakra.AlertIcon, {}), _jsx(chakra.AlertTitle, { children: (error === null || error === void 0 ? void 0 : error.message) || ((_a = (error || '')) === null || _a === void 0 ? void 0 : _a.toString()) }), !!(error === null || error === void 0 ? void 0 : error.stack) && _jsx(chakra.AlertDescription, { children: _jsx("pre", { children: error === null || error === void 0 ? void 0 : error.stack }) })] }) });
            }, onMounted: (setError) => setErrorRef.current = setError, children: (typeof (Component) === 'function') ? _jsx(_Fragment, { children: [_jsx(ClientHandlerRenderer, Object.assign({ Component: Component }, props, { fillSize: fillSize, link: _ml.byId[linkId], ml: _ml, onClose: onClose }), Component.toString())] }) : _jsx(_Fragment, {}) }) }));
}
//# sourceMappingURL=client-handler.js.map